BERGeneralDecoder Class Reference

BER General Decoder. More...

`#include <asn.h>`

Inheritance diagram for BERGeneralDecoder:

## Public Types

enum | { DefaultTag = SEQUENCE | static_cast<int>(CONSTRUCTED) }
| Default ASN.1 tag. More...

## Public Member Functions

| BERGeneralDecoder (BufferedTransformation &inQueue)
| Construct an ASN.1 decoder.
| BERGeneralDecoder (BufferedTransformation &inQueue, byte asnTag)
| Construct an ASN.1 decoder.
| BERGeneralDecoder (BERGeneralDecoder &inQueue, byte asnTag)
| Construct an ASN.1 decoder.
bool | IsDefiniteLength () const
| Determine length encoding.
lword | RemainingLength () const
| Determine remaining length.
bool | EndReached () const
| Determine end of stream.
byte | PeekByte () const
| Determine next octet.
void | CheckByte (byte b)
| Determine next octet.
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes to another BufferedTransformation.
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes to another BufferedTransformation.
void | MessageEnd ()
| Signals the end of messages to the object.
Public Member Functions inherited from Store
| Store ()
| Construct a Store.
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation.
unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object.
bool | GetNextMessage ()
| Start retrieving the next message.
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
Public Member Functions inherited from AutoSignaling< InputRejecting< BufferedTransformation > >
| AutoSignaling (int propagation=-1)
| Construct an AutoSignaling.
void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals.
int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value.
Public Member Functions inherited from InputRejecting< BufferedTransformation >
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input a byte array for processing.
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation.
bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation.
size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel.
bool | ChannelMessageSeriesEnd (const std::string &channel, int messageEnd, bool blocking)
| Marks the end of a series of messages on a channel.
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object.
virtual bool | Attachable ()
| Determines whether the object allows attachment.
virtual BufferedTransformation * | AttachedTransformation ()
| Returns the object immediately attached to this object.
virtual const BufferedTransformation * | AttachedTransformation () const
| Returns the object immediately attached to this object.
virtual void | Detach (BufferedTransformation *newAttachment=NULL)
| Delete the current attachment chain and attach a new one.
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain.
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing.
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing.
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing.
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing.
size_t | PutWord64 (word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing.
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller.
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee.
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee.
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object.
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message.
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee.
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects.
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation.
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation.
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation.
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval.
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval.
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte.
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes.
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte.
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes.
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word.
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word.
size_t | GetWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 64-bit word.
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word.
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word.
size_t | PeekWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 64-bit word.
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer.
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object to another BufferedTransformation.
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation.
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval.
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval.
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages.
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation.
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation.
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation.
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation.
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series.
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series.
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series.
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation.
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation.
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel.
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel.
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel.
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel.
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel.
size_t | ChannelPutWord64 (const std::string &channel, word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing on a channel.
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message.
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message.
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller.
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel.
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel.
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object.

## Detailed Description

BER General Decoder.

Definition at line 379 of file asn.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Default ASN.1 tag.

Definition at line 383 of file asn.h.

## Constructor & Destructor Documentation

## BERGeneralDecoder() [1/3]

BERGeneralDecoder::BERGeneralDecoder | ( | BufferedTransformation & | inQueue | ) |

explicit

Construct an ASN.1 decoder.

Parameters

  inQueue | input byte queue

BERGeneralDecoder uses DefaultTag

## BERGeneralDecoder() [2/3]

BERGeneralDecoder::BERGeneralDecoder | ( | BufferedTransformation & | inQueue,
|  | byte | asnTag )

explicit

Construct an ASN.1 decoder.

Parameters

  inQueue | input byte queue
  asnTag | ASN.1 tag

## BERGeneralDecoder() [3/3]

BERGeneralDecoder::BERGeneralDecoder | ( | BERGeneralDecoder & | inQueue,
|  | byte | asnTag )

explicit

Construct an ASN.1 decoder.

Parameters

  inQueue | input byte queue
  asnTag | ASN.1 tag

## Member Function Documentation

## IsDefiniteLength()

bool BERGeneralDecoder::IsDefiniteLength | ( |  | ) | const

inline

Determine length encoding.

Returns
  true if the ASN.1 object is definite length encoded, false otherwise

Definition at line 404 of file asn.h.

## RemainingLength()

lword BERGeneralDecoder::RemainingLength | ( |  | ) | const

inline

Determine remaining length.

Returns
  number of octets that remain to be consumed

RemainingLength() is only valid if IsDefiniteLength() returns true.

Definition at line 412 of file asn.h.

## EndReached()

bool BERGeneralDecoder::EndReached | ( |  | ) | const

Determine end of stream.

Returns
  true if all octets have been consumed, false otherwise

## PeekByte()

byte BERGeneralDecoder::PeekByte | ( |  | ) | const

Determine next octet.

Returns
  next octet in the stream

PeekByte does not consume the octet.

Exceptions

  BERDecodeError | if there are no octets remaining

## CheckByte()

void BERGeneralDecoder::CheckByte | ( | byte | b | ) |

Determine next octet.

CheckByte reads the next byte in the stream and verifies the octet matches b.

Exceptions

  BERDecodeError | if the next octet is not b

## TransferTo2()

size_t BERGeneralDecoder::TransferTo2 | ( | BufferedTransformation & | target,
|  | lword & | transferBytes,
|  | const std::string & | channel = DEFAULT_CHANNEL,
|  | bool | blocking = true )

virtual

Transfer bytes to another BufferedTransformation.

Parameters

  target | the destination BufferedTransformation
  transferBytes | the number of bytes to transfer
  channel | the channel on which the transfer should occur
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the transfer block (i.e., bytes not transferred)

TransferTo2() removes bytes and moves them to the destination. Transfer begins at the index position in the current stream, and not from an absolute position in the stream.

transferBytes is an IN and OUT parameter. When the call is made, transferBytes is the requested size of the transfer. When the call returns, transferBytes is the number of bytes that were transferred.

Implements BufferedTransformation.

## CopyRangeTo2()

size_t BERGeneralDecoder::CopyRangeTo2 | ( | BufferedTransformation & | target,
|  | lword & | begin,
|  | lword | end = LWORD_MAX,
|  | const std::string & | channel = DEFAULT_CHANNEL,
|  | bool | blocking = true ) const

virtual

Copy bytes to another BufferedTransformation.

Parameters

  target | the destination BufferedTransformation
  begin | the 0-based index of the first byte to copy in the stream
  end | the 0-based index of the last byte to copy in the stream
  channel | the channel on which the transfer should occur
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the copy block (i.e., bytes not copied)

CopyRangeTo2 copies bytes to the destination. The bytes are not removed from this object. Copying begins at the index position in the current stream, and not from an absolute position in the stream.

begin is an IN and OUT parameter. When the call is made, begin is the starting position of the copy. When the call returns, begin is the position of the first byte that was not copied (which may be different than end). begin can be used for subsequent calls to CopyRangeTo2().

Implements BufferedTransformation.

## MessageEnd()

void BERGeneralDecoder::MessageEnd | ( |  | ) |

Signals the end of messages to the object.

Call this to denote end of sequence

The documentation for this class was generated from the following file:

- asn.h